function [M1,P] = ilu0(M)
%
%  
%

M1=M;
[n,n]=size(M1);
k=[1:n];
v=ones(n);
P=sparse(k,k,v,n,n);

for i=2:n
   for k=1:i-1
      if (M1(k,k)==0)
         [m,index]=max(abs(M1(k+1:n,k)));
         M1([k index],:)=M1([index k],:);
         P([k index],:)=P([index k],:)
      end
      if M1(i,k)~=0 
         M1(i,k)=M1(i,k)/M1(k,k); 
      end
      for j=k+1:n    
         if M1(i,j)~=0
            M1(i,j)=M1(i,j)-M1(i,k)*M1(k,j);
         end
      end
   end
end
return M1

end



